Ti.include('redux.js');

Ti.App.loadedWindows = [];

// Include our utilities in every JS context
includeGlobal('includes/underscore.js', 
	'includes/utilities.js', 
	'includes/properties.js', 
	'includes/widget_factory.js',
	'includes/remote_api.js');

clearSessionSelections();

// Tell the compiler which modules we are going to use; note there are no () on these!
var used = [Ti.UI.createTabGroup, 
	Ti.UI.createWindow, 
	Ti.UI.createTab, 
	Ti.UI.createLabel,
	Ti.UI.createTextField,	 
	Ti.Platform.locale, 
	Ti.UI.createTableView,
	Ti.UI.createTableViewRow,
	Ti.UI.createSearchBar, 
	Ti.UI.createImageView,
	Ti.UI.createView,
	Ti.UI.createButton,
	Ti.UI.createScrollView,
	Ti.UI.createActivityIndicator];

var winHome = Ti.UI.createWindow({
	id: 'win_home',
	title:'Events Calendar',
	navBarHidden:true, // Hide the title bar on iOS
	url: 'screens/home.js',
	tabBarHidden:true,
	backgroundImage: imagePath('background.png'),
	backButtonTitleImage:null,
	backButtonTitle:'Back',
	animate:true,
	leftNavButton: null, // Disable the back button on Android
	exitOnClose: true,	// Going back from here (on Android) should quit
});

winHome.orientationModes = [Ti.UI.PORTRAIT, Ti.UI.UPSIDE_PORTRAIT]; // Lock the user to portrait / upside down portrait

if(isIOS()) {
	// Need to create a tabgroup for iPhone but dont show it.
	// Without a tabgroup the title bar will not show on the iPhone.
	var hiddenTabGroup = new TabGroup();
	
	var hiddenTab = new Tab({
	    title:"Main",
	    window: winHome
	});
	 
	hiddenTabGroup.addTab(hiddenTab);
	hiddenTabGroup.open();
}
else
{
	// Dont use tabs in Android. We dont show them.
	winHome.open();
}