var winHome = Ti.UI.createWindow({
	id: 'win_home',
	title:'Events Calendar',
	navBarHidden:false, // Hide the title bar on iOS
	backgroundColor: 'white',
	backButtonTitleImage:null,
	backButtonTitle:'Back',
	leftNavButton: null, // Disable the back button on Android
	exitOnClose: true,	// Going back from here (on Android) should quit
	orientationModes: [ Titanium.UI.PORTRAIT, Titanium.UI.UPSIDE_PORTRAIT ], // Lock the user to portrait / upside down portrait
});

var db = Ti.Database.open('tasksDB');
db.close();

var table = Ti.UI.createTableView({
	width: '100%',
	height: '290',
	top: 0,
})
winHome.add(table);

function displayHoursAndMinutes(seconds)
{
	var minutes = seconds / 60;
	var h = Math.floor(minutes / 60).toString();
	var m = Math.floor(minutes % 60).toString();
	if(m.length == 1) m = '0' + m;
	return h  + ':' + m;
}

function createRow(title, durationSeconds)
{
	var row = Ti.UI.createTableViewRow({
	});
	
	var titleLabel = Ti.UI.createLabel({
		text: title,
		left: 40,
		height: 20,
		width: 200,
		autoellipsize: true,
	})
	
	var amount = Ti.UI.createLabel({
		text: displayHoursAndMinutes(durationSeconds),
		textAlign: 'right',
		width: 40,
		left: 250,
		height: 20,
		color: (durationSeconds === 0 ? 'gray' : 'black'),
	})
	
	row.add(titleLabel);
	row.add(amount);
	
	return row;
}

function createSummaryRow()
{
	var row = Ti.UI.createTableViewRow({
		backgroundColor: '#ccc',
		height: 30,
	});
	
	return row;
}

var rows = [];
rows.push(createRow('Test 1', 0 * 60));
rows.push(createRow('Test 2', 59 * 60));
rows.push(createRow('Test 3 with a really really really really really really long title', 60 * 60));

var summaryRow = createSummaryRow();
rows.push(summaryRow); 

table.setData(rows);

var label = Ti.UI.createLabel({text:'unknown'});

winHome.add(label);

winHome.open();

var i = 0;

var startTicks = new Date().getTime();

function tick()
{
	var currentTime = new Date().getTime();
	label.text = ((currentTime - startTicks) / 1000) + ' / ' + i;
	i++; 
	setTimeout(tick, 1000);
}


setTimeout(tick, 1000);
