/**
 * Central collection of all application properties.
 */
function AppProperties() {}

AppProperties.prototype.MASTER_WINDOW_PROPERTIES = {
	backButtonTitleImage:null,
	backButtonTitle:'Back',
	animate:true,
	fullscreen:false,
	backgroundImage:imagePath('background.png'),
	navBarHidden:false, // Show the title bar on iOS
};

AppProperties.prototype.KEY_LAST_SECTION_NAME = "shared_last_section_name";

AppProperties.prototype.KEY_LAST_LAT = "shared_last_lat";
AppProperties.prototype.KEY_LAST_LNG = "shared_last_lng";

AppProperties.prototype.KEY_COUNCIL_ID = "shared_council_id";
AppProperties.prototype.KEY_COUNCIL_NAME = "shared_council_name";

AppProperties.prototype.KEY_REGION_ID = "shared_region_id";
AppProperties.prototype.KEY_REGION_NAME = "shared_region_name";

AppProperties.prototype.KEY_CATEGORY_ID = "shared_category_id";
AppProperties.prototype.KEY_CATEGORY_NAME = "shared_category_name";

AppProperties.prototype.KEY_FILTER_ID = "shared_filter_id";
AppProperties.prototype.KEY_FILTER_NAME = "shared_filter_name";
AppProperties.prototype.KEY_FILTER_BAR_COLOR = "shared_filter_bar_color";
AppProperties.prototype.KEY_FILTER_DARK_BAR_COLOR = "shared_filter_dark_bar_color";
AppProperties.prototype.KEY_FILTER_COLOR_SCHEME = "shared_filter_color_scheme";
AppProperties.prototype.KEY_DATE = "shared_date";

AppProperties.prototype.KEY_EVENT_START_DATE = "shared_event_start_date";
AppProperties.prototype.KEY_EVENT_END_DATE = "shared_event_end_date";
AppProperties.prototype.KEY_EVENT_NAME = "shared_event_name";
AppProperties.prototype.KEY_EVENT_DESCRIPTION = "shared_event_description";
AppProperties.prototype.KEY_EVENT_LOCATION = "shared_event_loc";
AppProperties.prototype.KEY_EVENT_STREET = "shared_event_street";
AppProperties.prototype.KEY_EVENT_TOWN = "shared_event_town";
AppProperties.prototype.KEY_EVENT_STATE = "shared_event_state";
AppProperties.prototype.KEY_EVENT_MESSAGE = "shared_event_message";
AppProperties.prototype.KEY_EVENT_COUNCIL = "shared_event_council";
AppProperties.prototype.KEY_EVENT_REGION = "shared_event_region";

AppProperties.prototype.KEY_EVENT_PHONE = "shared_event_phone";
AppProperties.prototype.KEY_EVENT_EMAIL = "shared_event_email";
AppProperties.prototype.KEY_EVENT_WEBSITE = "shared_event_website";
AppProperties.prototype.KEY_EVENT_CAT1 = "shared_event_cat1";
AppProperties.prototype.KEY_EVENT_CAT2 = "shared_event_cat2";

AppProperties.prototype.KEY_EVENT_PERSON_NAME = "shared_event_person_name";
AppProperties.prototype.KEY_EVENT_PERSON_EMAIL = "shared_event_person_email";
AppProperties.prototype.KEY_EVENT_PERSON_PHONE = "shared_event_person_phone";


AppProperties.prototype.ALL_SUGGEST_EVENT_KEYS = [
	AppProperties.prototype.KEY_EVENT_START_DATE,
	AppProperties.prototype.KEY_EVENT_END_DATE,
	AppProperties.prototype.KEY_EVENT_NAME,
	AppProperties.prototype.KEY_EVENT_DESCRIPTION,
	AppProperties.prototype.KEY_EVENT_LOCATION,
	AppProperties.prototype.KEY_EVENT_STREET,
	AppProperties.prototype.KEY_EVENT_TOWN,
	AppProperties.prototype.KEY_EVENT_STATE,
	AppProperties.prototype.KEY_EVENT_MESSAGE,
	AppProperties.prototype.KEY_EVENT_COUNCIL,
	AppProperties.prototype.KEY_EVENT_REGION,
	
	AppProperties.prototype.KEY_EVENT_PHONE,
	AppProperties.prototype.KEY_EVENT_EMAIL,
	AppProperties.prototype.KEY_EVENT_WEBSITE,
	AppProperties.prototype.KEY_EVENT_CAT1,
	AppProperties.prototype.KEY_EVENT_CAT2,
	
	AppProperties.prototype.KEY_EVENT_PERSON_NAME,
	AppProperties.prototype.KEY_EVENT_PERSON_EMAIL,
	AppProperties.prototype.KEY_EVENT_PERSON_PHONE,
];

AppProperties.prototype.API_URL = "http://10.0.12.136/~asiddiqui";
//AppProperties.prototype.API_URL = "http://uat.www.vic.gov.au/api";

// All access to these properties will be through this object.
appProps = new AppProperties();

function getSharedPropertyAsInt(key) {
	if(Titanium.App.Properties.hasProperty(key)) {
		return Titanium.App.Properties.getInt(key);
	} else {
		return null;
	}
}

function setSharedPropertyAsString(key, value) {
	Ti.API.debug('setSharedPropertyAsString: ' + key + ' = ' + JSON.stringify(value));
	if(value == null) {
		return;
	}
	Titanium.App.Properties.setString(key, value.toString());
}

function getSharedPropertyAsString(key) {
	if(Titanium.App.Properties.hasProperty(key)) {
		return Titanium.App.Properties.getString(key);
	} else {
		return "";
	}
}

function setSelectedCategory(id, name) {
	Titanium.App.Properties.setInt(appProps.KEY_CATEGORY_ID, id);
	Titanium.App.Properties.setString(appProps.KEY_CATEGORY_NAME, name);
}

function getSelectedCategory() {
	if(Titanium.App.Properties.hasProperty(appProps.KEY_CATEGORY_ID)) {
		return {
			id:Titanium.App.Properties.getInt(appProps.KEY_CATEGORY_ID), 
			name:Titanium.App.Properties.getString(appProps.KEY_CATEGORY_NAME)
		};
	} else {
		return null;
	}	
}

function isCategorySelected() {
	if(Titanium.App.Properties.hasProperty(appProps.KEY_CATEGORY_ID)) {
		return true;
	} else	 {
		return false;
	}
}

function removeSelectedCategory() {
	Titanium.App.Properties.removeProperty(appProps.KEY_CATEGORY_ID);
	Titanium.App.Properties.removeProperty(appProps.KEY_CATEGORY_NAME);
}


function doSetFilter(idName, nameName, id, name)
{
	Titanium.App.Properties.setInt(idName, id);
	Titanium.App.Properties.setString(nameName, name);
}

function doClearFilter(idName, nameName)
{
	Titanium.App.Properties.removeProperty(idName);
	Titanium.App.Properties.removeProperty(nameName);
}

function doGetFilter(idName, nameName)
{
	if(Titanium.App.Properties.hasProperty(idName)) {
		var obj = {
			id:Titanium.App.Properties.getInt(idName),
			name:Titanium.App.Properties.getString(nameName)
		};
		return obj;
	} else {
		return null;
	}
}

function clearFilters()
{
	clearRegionFilter();
	clearCouncilFilter();
	removeSelectedCategory();
}

function setRegionFilter(id, name) { doSetFilter(appProps.KEY_REGION_ID, appProps.KEY_REGION_NAME, id, name); }
function clearRegionFilter() { doClearFilter(appProps.KEY_REGION_ID, appProps.KEY_REGION_NAME); }
function getRegionFilter() { return doGetFilter(appProps.KEY_REGION_ID, appProps.KEY_REGION_NAME); }

function setCouncilFilter(id, name) { doSetFilter(appProps.KEY_COUNCIL_ID, appProps.KEY_COUNCIL_NAME, id, name); }
function clearCouncilFilter() { doClearFilter(appProps.KEY_COUNCIL_ID, appProps.KEY_COUNCIL_NAME); }
function getCouncilFilter() { return doGetFilter(appProps.KEY_COUNCIL_ID, appProps.KEY_COUNCIL_NAME); }


function clearLastLatLng()
{
	if(Titanium.App.Properties.hasProperty(appProps.KEY_LAST_LAT)) {
		Titanium.App.Properties.removeProperty(appProps.KEY_LAST_LAT);
		Titanium.App.Properties.removeProperty(appProps.KEY_LAST_LNG);
	}
}

function setLastLatLng(lat, lng)
{
	Titanium.App.Properties.setString(appProps.KEY_LAST_LAT, lat);
	Titanium.App.Properties.setString(appProps.KEY_LAST_LNG, lng);
}

function getLastLatLng()
{
	if(Titanium.App.Properties.hasProperty(appProps.KEY_LAST_LAT)) {
		return {
			lat:Titanium.App.Properties.getString(appProps.KEY_LAST_LAT),
			lng:Titanium.App.Properties.getString(appProps.KEY_LAST_LNG)
		};
	} else {
		return null;
	}
}





function setColors(barColor, darkBarColor, colorScheme)
{
	Titanium.App.Properties.setString(appProps.KEY_FILTER_BAR_COLOR, barColor);
	Titanium.App.Properties.setString(appProps.KEY_FILTER_DARK_BAR_COLOR, darkBarColor);
	Titanium.App.Properties.setString(appProps.KEY_FILTER_COLOR_SCHEME, colorScheme);
}

function clearPrimaryFilter()
{

	Titanium.App.Properties.removeProperty(appProps.KEY_FILTER_ID);
	Titanium.App.Properties.removeProperty(appProps.KEY_FILTER_NAME);
}

function setPrimaryFilter(id, name) {
	Titanium.App.Properties.setInt(appProps.KEY_FILTER_ID, id);
	Titanium.App.Properties.setString(appProps.KEY_FILTER_NAME, name);
}

function getPrimaryFilter() {
	if(Titanium.App.Properties.hasProperty(appProps.KEY_FILTER_ID)) {
		return {
			id:Titanium.App.Properties.getInt(appProps.KEY_FILTER_ID),
			name:Titanium.App.Properties.getString(appProps.KEY_FILTER_NAME)
		};
	} else {
		Ti.API.warn(">>> No primary filter has been found");
		return null;
	}
}

function resetSelectedDateForSection(sectionName){
	if(getSharedPropertyAsString(appProps.KEY_LAST_SECTION_NAME) != sectionName)
	{
		setSharedPropertyAsString(appProps.KEY_LAST_SECTION_NAME, sectionName);
		setSelectedDate(new Date());
	}
}

function setSelectedDate(date) {
	Titanium.App.Properties.setString(appProps.KEY_DATE, date.toString());
}

function getSelectedDate() {
	if(Titanium.App.Properties.hasProperty(appProps.KEY_DATE)) {
		return new Date(Titanium.App.Properties.getString(appProps.KEY_DATE));
	} else {
		return new Date();
	}	
}

function removeSelectedDate(date) {
	Titanium.App.Properties.removeProperty(appProps.KEY_DATE);
}

// Submit an event property storage
function setEventStartDate(date) {
	Titanium.App.Properties.setString(appProps.KEY_EVENT_START_DATE, date.toString());
}

function getEventStartDate() {
	if(Titanium.App.Properties.hasProperty(appProps.KEY_EVENT_START_DATE)) {
		return Titanium.App.Properties.getString(appProps.KEY_EVENT_START_DATE);
	} else {
		return "";
	}
}


// Remove all properties. Do this upon app start up to reset everything.
function clearSessionSelections() {
	var props = Titanium.App.Properties.listProperties();
	for (var c=0;c<props.length;c++)
	{
	    var value = Titanium.App.Properties.removeProperty(props[c]);
	}
}