var windowTracker = {
	
};

(function() { 
	// Unload all tracked windows.
	windowTracker.unLoadTrackedWindows = function() {
		var windows = Ti.App.loadedWindows;

		Ti.API.debug('windowTracker.unLoadTrackedWindows() - new window stack count is ' + windows.length);
			
		// There should always be one screen on the stack else you will get a corrupt navbar
		// remove all but one window..else navbar is corrupted
		if(windows.length > 1) {
			Ti.API.debug('>>>> going through windows');
			//for(i = windows.length - 1; i>0; i--) {
			for(i = 0; i<windows.length; i++) {	
				var winToRemove = windows[i];
				
				if(winToRemove != null) {
					Ti.API.debug('>>>> Got a window with url ' + winToRemove.url);
					
					if(isIPhone() || isAndroid()) {
						Ti.API.debug('>>>> Removing...a window with url ' + winToRemove.url);
						winToRemove.close();
					}
				}
			}
		}
		
		Ti.App.loadedWindows = [];
	};
	
	// Open a window and add it to the tracked window list
	windowTracker.openAndTrackWindowForClosing = function(newWin) {
		// Dont do selective window tracking fori iPad as we are tracking every window.
		if(!isIPad()) {
			// Add the window to the global list of windows loaded.
			var windows = Ti.App.loadedWindows;
			windows.push(newWin);
			Ti.App.loadedWindows = windows;
			//alert('window stack count: ' + windows.length);

			Ti.API.debug('windowTracker.openAndTrackWindowForClosing() - new window stack count is ' + windows.length);
		}
		
		loadWindow(newWin);
	};
	
	windowTracker.popWindow = function()
	{
		var windows = Ti.App.loadedWindows;
		var win = windows.pop();
		Ti.App.loadedWindows = windows;
		
		Ti.API.debug('windowTracker.popWindow() - new window stack count is ' + windows.length);
		
		return win;
	};
	
	windowTracker.closeWindow = function()
	{
		if(!isIPad()) {
			var win = windowTracker.popWindow();
			win.close();
			//alert('window stack count: ' + windows.length);
		}
		else
		{
			win().close();
		}
	};
	
	//
	windowTracker.clearTrackedWindowStack = function() {
		Ti.App.loadedWindows = [];
	};
	
})();