Ti.include('../redux.js');
var w = win();
var rows = [];

// Android requires the width is specified
if(isAndroid()){
	w.width = Ti.Platform.displayCaps.platformWidth;
	w.orientationModes = [ Ti.UI.PORTRAIT ];
}

/*
 * Adds a new row containing the specified label to the table
 */
function addRow(label, height)
{
	if(height == null)
		height = 'auto';
	
	var row = new TableViewRow({
		height: height
	});
	
	if(isIOS()) {
		row.selectionStyle = Ti.UI.iPhone.TableViewCellSelectionStyle.NONE;
	}
	
	label.left = app.tablePadLeft;
	
	row.add(label);
	rows.push(row);
}

var itemWidth = w.width * 0.9;

addRow(new Label({ text: 'Events Calendar', top: 20, font: { fontSize: 16, fontWeight: 'bold', }, height:'auto', width:'auto', textAlign:'left',}));
addRow(new Label({ text: 'Version 1.0 b14 - ' + 'Avail. mem: ' + Ti.Platform.availableMemory, font: { size: 10, }, height:'30', width:'auto', textAlign:'left',}));
addRow(new Label({ text: L('about_para_1') + '\n ', font: { size: 10, }, height:'auto', width:w.width * 0.9, textAlign:'left',}));

var linkOptions = { height: 20, textAlign:'left', width: itemWidth, top: 10, };

if(isAndroid())
{
	linkOptions.top = 5;
	linkOptions.height = 20;
}

addRow(createLink('Information Victoria', 'http://www.vic.gov.au/about.html', linkOptions), 30);
addRow(createLink('Department of Business and Innovation', 'http://www.dbi.vic.gov.au', linkOptions), 30);
addRow(new Label({ text: 'and', font: { size: 10, }, top: 10, height:'auto', width:itemWidth, textAlign:'left',}));
addRow(createLink('Deloitte', 'http://online.deloitte.com.au', linkOptions), 30);

addRow(new Label({ text: L('about_para_2') + '\n ', font: { size: 10, }, height:'auto', width:w.width * 0.9, textAlign:'left', }));

addRow(createLink('Feedback', 'https://www.vic.gov.au/feedback.html', linkOptions), 30);

addRow(createLink('Rate this app', 'http://online.deloitte.com.au', linkOptions), 30);

var table = Titanium.UI.createTableView({
	height:getWindowHeight(w),
	width:w.width,
	backgroundColor: '#fff',
	separatorStyle: Titanium.UI.iPhone.TableViewSeparatorStyle.NONE,
	data: rows,
	separatorColor:'white',
});

if(isAndroid()) {
	table.height = getScreenHeight();
	table.separatorColor = '#FFF';
}

w.add(table);

if(isIPhone()) {
	// Done button is not required on iPad - navigation panel is displayed to the left
	// Done button is not required on Android - they have their own Back button
	var button = new Button({ title: 'Done' });
	w.rightNavButton = button;
	button.addEventListener('click', function() {
		win().close();
	});
}


