Ti.include('../redux.js');

// Load the currently selected viewing date from the app properties, but
// if it's not set (blank string) use today's date
var viewingDate = getSharedPropertyAsString(win().returnValueKey);
viewingDate = (viewingDate == '' ? new Date() : new Date(viewingDate));

// Functions used to get/set by the calendar view header
function getViewingDate() { return viewingDate; }
function setViewingDate(date) { viewingDate = date; }

var calendarView = calendarHeaderView(null, false, true, true, getViewingDate, setViewingDate);

var w = win();
w.add(calendarView);
w.layout = 'vertical';

Ti.API.info(">>> win().height is " + win().height + " screen height is " + getScreenHeight() );
//var tableView = makeTable(getScreenHeight() - calendarView.height);
var tableView = makeFullscreenTable(calendarView.height);
w.add(tableView);

$(w).focus(function(){ 
	refreshTableView();
});

// Add swipe detection to the window. Note that the swipe detection
// is tracked and duplicate events are prevented from firing for a second
// to prevent the event firing twice in a row (TI bug?)
var swipeDirection = 'none';
tableView.addEventListener('swipe', function(event){
	if(event.direction != swipeDirection)
	{
		swipeDirection = event.direction;
		if(event.direction === 'left')
		{
			viewingDate = nextMonth(viewingDate);
			refreshTableView();
		}
		else if(event.direction === 'right')
		{
			viewingDate(previousMonth(viewingDate));
			refreshTableView();
		}
		
		setTimeout(function() { swipeDirection = 'none'; }, 1000);
	}
});

function refreshTableView() {
	Ti.App.fireEvent('updateCalendarHeader');	
	showLoading(tableView);
	
	var rows = [];
	var year = viewingDate.getFullYear(), month = viewingDate.getMonth();
	var lastDayInMonth = daysInMonth(month, year);
	for(var i = 1; i <= lastDayInMonth; i++)
	{
		var theDate = new Date(year, month, i)

		var rowDateStringy = theDate.getDate().toString() + " " + getMonthName(month) + ", " + getDayName(theDate.getDay());
		var row = makeLinkedStyledRow(theDate.getTime(), rowDateStringy, null, null, selectDate, i > 1);
		rows.push(row);
	}
	tableView.setData(rows);
}

function selectDate(event)
{
	// Fix for IV-140 (maybe?) - just do not allow a null date to be passed back
	if(event == null || event.source == null || event.source.id == null)
	{
		return;
	}
	
	newDate = new Date(event.source.id);
	Ti.API.debug('selectDate called, setting ' + win().returnValueKey + ' to: ' + JSON.stringify(newDate));
	setSharedPropertyAsString(win().returnValueKey, newDate);
	unloadCurrentWindow();
}