Ti.include('../redux.js');

// Setup the category filter row (with test category selected)
var filteredEventLocations = [];

function refreshTableView() {	
	Ti.API.debug('refreshTableView()');
	Ti.App.fireEvent('updateCalendarHeader');
	loadSearchResults(win().searchQuery, populateSearchResults);	
}

function populateSearchResults(data)
{
	Ti.API.trace('populateSearchResults')
	
	if(data.total_results == null)
	{
		screenTitleLabel.hide();
		tableView.top = 0;
	}
	else
	{
		screenTitleLabel.text = data.total_results + ' results found';
		screenTitleLabel.show();
		tableView.top = 30;
	}
	
	populateEventsTable(tableView, evtField.FieldsWithDates, data, true);
}

var screenTitleLabel = createFilterHeader('Loading...');

win().add(screenTitleLabel);

var tableView = makeFullscreenTable(30);
if(isAndroid()) {
	tableView.backgroundSelectedColor = '#999';
	tableView.footerView = Ti.UI.createView({height:70,width:getScreenWidth(),backgroundColor:'transparent', visible:false});
}
win().add(tableView);
showLoading(tableView);

// Setup event bindings
refreshTableView();